/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  
*/

/*=========================================================================                                                                               
Program:   bbtk
Module:    $RCSfile$
Language:  C++
Date:      $Date$
Version:   $Revision$
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         

/**
*  \file 
*  \brief Class bbtk::manualConnectorContourView 
*/


#include "manualConnectorContourView.h"

namespace bbtk
{


	//=========================================================================

	manualConnectorContourView::manualConnectorContourView()
	{
	}

	//=========================================================================

	manualConnectorContourView::~manualConnectorContourView()
	{
	}

	//=========================================================================

	void manualConnectorContourView::TransfromCoordViewWorld(double &X, double &Y, double &Z, int type)
	{
		// Make the conversion using the system of creaMaracasVisu
		_wxvtkbaseview->TransCoordScreenToWorld(X,Y,Z,type);
	}

	//=========================================================================

	void manualConnectorContourView::updateStartAndEnd(double* start , double* end)
	{
		// Update contour first and last point
		_manContModel->MovePoint(0,start[0],start[1],start[2]);
		_manContModel->MovePoint(_manContModel->GetSizeLstPoints()-1,end[0],end[1],end[2]);
		
		Refresh();
	}

	//=========================================================================

	void manualConnectorContourView::AddControlPoints()
	{
		vtkRenderer * theRenderer = _wxvtkbaseview->GetRenderer();
		SetIfViewControlPoints( true );
		 if( _viewControlPoints )
		 {
			int i,size=_lstViewPoints.size();
			//The first and last points are avoided
			for (i=1;i<size-1; i++)
			{
				vtkActor * pointActor = _lstViewPoints[i]->GetVtkActor();
				theRenderer->AddActor( pointActor );
			}
		 }
	}
	
	//=========================================================================

	void manualConnectorContourView::RefreshText()  // virtual
	{
		// The text that goes with the contour is not shown
	}


}  // EO namespace bbtk

// EOF

